signatureColored = '[|cff00FF7FA|cff00ff00G|cff00FF7FA|r]';
local name, addon = ...
local login = true;
alloweduserlist = "";
blockeduserlist = "";
local MyInterfaceOptions = {};
function AutoGroupAccept_Init()
	--------------------------------------------------------------------------------------------------
	-- Register Events -------------------------------------------------------------------------------
	--------------------------------------------------------------------------------------------------
		AutoGroupAccept:RegisterEvent("PARTY_INVITE_REQUEST");
		AutoGroupAccept:RegisterEvent("ADDON_LOADED");
		AutoGroupAccept:RegisterEvent("PLAYER_LOGIN");
	--------------------------------------------------------------------------------------------------
	-- GUI -------------------------------------------------------------------------------------------
	--------------------------------------------------------------------------------------------------
	-- Interface Options -----------------------------------------------------------------------------
	--------------------------------------------------------------------------------------------------
		MyInterfaceOptions.panel = CreateFrame( "Frame", "AGAInterfaceAddons", UIParent );
		MyInterfaceOptions.panel.name = "AutoGroupAccept";
		function MyInterfaceOptions.panel.refresh()
			 xpcall(function()
			  updateCheckboxes(); GetAllowedUsers();
			 end, geterrorhandler())
		end
		InterfaceOptions_AddCategory(MyInterfaceOptions.panel);
		
		MyInterfaceOptions.childpanelList = CreateFrame( "Frame", "AGAInt_Characters", MyInterfaceOptions.panel);
		MyInterfaceOptions.childpanelList.name = "Character list";
		MyInterfaceOptions.childpanelList.parent = MyInterfaceOptions.panel.name;
		InterfaceOptions_AddCategory(MyInterfaceOptions.childpanelList);
		
		MyInterfaceOptions.childpanelHelp = CreateFrame( "Frame", "AGAInt_Help", MyInterfaceOptions.panel);
		MyInterfaceOptions.childpanelHelp.name = "Help";
		MyInterfaceOptions.childpanelHelp.parent = MyInterfaceOptions.panel.name;
		InterfaceOptions_AddCategory(MyInterfaceOptions.childpanelHelp);
		--------------------------------------------------------------------------------------------------
		-- Table value check -----------------------------------------------------------------------------
		--------------------------------------------------------------------------------------------------
		MyInterfaceOptions.childpanelAbout = CreateFrame( "Frame", "AGAInt_About", MyInterfaceOptions.panel);
		MyInterfaceOptions.childpanelAbout.name = "About";
		MyInterfaceOptions.childpanelAbout.parent = MyInterfaceOptions.panel.name;
		InterfaceOptions_AddCategory(MyInterfaceOptions.childpanelAbout);
	--------------------------------------------------------------------------------------------------
	-- Backgrounds -----------------------------------------------------------------------------------
	--------------------------------------------------------------------------------------------------
	-- First-time --
		local AGAFirstTime = CreateFrame("Frame","AGAFirstTime",UIParent);
		AGAFirstTime:SetFrameStrata("DIALOG");
		AGAFirstTime:SetWidth(340);
		AGAFirstTime:SetHeight(240);
		AGAFirstTime:EnableMouse(true);
		AGAFirstTime:SetBackdrop({
		bgFile = "Interface/DialogFrame/UI-DialogBox-Background", 
		edgeFile = "Interface/DialogFrame/UI-DialogBox-Border", tile = true, tileSize = 32, edgeSize = 32, 
		insets = { left = 11, right = 12, top = 12, bottom = 11 }});
		AGAFirstTime:SetPoint("CENTER",0,0);
	--------------------------------------------------------------------------------------------------
	-- Title & Text -----------------------------------------------------------------------------------------
	--------------------------------------------------------------------------------------------------
	-- Configuration --
		local AGATitleText = AGAInterfaceAddons:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge");
		AGATitleText:SetPoint("TOP","AGAInterfaceAddons",3,-15);
		AGATitleText:SetWidth(600);
		AGATitleText:SetJustifyH("LEFT");
		AGATitleText:SetText("Config");
	-- About --
		local AGAAboutTitleText = AGAInt_About:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge");
		AGAAboutTitleText:SetPoint("TOP", "AGAInt_About", "TOP", 3, -15);
		AGAAboutTitleText:SetWidth(600);
		AGAAboutTitleText:SetJustifyH("LEFT");
		AGAAboutTitleText:SetText("About");
		local AGAAboutTitleText3 = AGAInt_About:CreateFontString(nil, "OVERLAY", "GameFontNormal");
		AGAAboutTitleText3:SetPoint("TOP", "AGAInt_About", "TOP", 3, -40);
		AGAAboutTitleText3:SetWidth(600);
		AGAAboutTitleText3:SetJustifyH("LEFT");
		AGAVersion = GetAddOnMetadata("AutoGroupAccept", "Version");
		AGAAboutTitleText3:SetText("|cff00FF7FAuto|cff00ff00Group|cff00FF7FAccept|r is all about accepting group invites from certain people. If for some reason something is not working correctly you can just shoot me an e-mail at |cff00ff00Utriax@gmail.com|r or visit my website at |cff00ff00Utriax.com|r for more information.\n\nAddon made by |cffB51D1DUtriax|r#|cffB51D1D1733|r, Tested by |cffB51D1DGlavock|r@|cffB51D1DStormrage|r and |cffB51D1DTydrolus|r@|cffB51D1DStormrage|r.".."\n\nVersion: ".. tostring(AGAVersion));
	-- First-time --
		local AGAFirstTimeTitle = AGAFirstTime:CreateTexture(nil, "ARTWORK");
		AGAFirstTimeTitle:SetPoint("TOP",0,13);
		AGAFirstTimeTitle:SetTexture("Interface/DialogFrame/UI-DialogBox-Header");
		AGAFirstTimeTitle:SetWidth(375);
		AGAFirstTimeTitle:SetHeight(64);
		local AGAFirstTimeTitleText = AGAFirstTime:CreateFontString(nil, "OVERLAY", "GameFontNormal");
		AGAFirstTimeTitleText:SetPoint("TOP",0,-1);
		AGAFirstTimeTitleText:SetText("|cff00FF7FAuto|cff00ff00Group|cff00FF7FAccept|r");
		local AGAFirstTimeTitleText1 = AGAFirstTime:CreateFontString(nil, "OVERLAY", "GameFontNormal");
		AGAFirstTimeTitleText1:SetPoint("TOPLEFT", 20, -60);
		AGAFirstTimeTitleText1:SetWidth(300);
		AGAFirstTimeTitleText1:SetText("Hi there!");
		local AGAFirstTimeTitleText2 = AGAFirstTime:CreateFontString(nil, "OVERLAY", "GameFontNormal");
		AGAFirstTimeTitleText2:SetPoint("TOPLEFT", 20, -90);
		AGAFirstTimeTitleText2:SetWidth(300);
		AGAFirstTimeTitleText2:SetText("So this is your first time using this addon eh? type |cff00FF7F/aga help|r for all the commands.");
		local AGAFirstTimeTitleText3 = AGAFirstTime:CreateFontString(nil, "OVERLAY", "GameFontNormal");
		AGAFirstTimeTitleText3:SetPoint("TOPLEFT", 20, -130);
		AGAFirstTimeTitleText3:SetWidth(300);
		AGAFirstTimeTitleText3:SetText("Or you can use the configuration panel to set the toggleable filters.");
	-- Characterlist --
		local AGACharacterlistAllowedText = AGAInt_Characters:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge");
		AGACharacterlistAllowedText:SetPoint("TOPLEFT", 10, -15);
		AGACharacterlistAllowedText:SetWidth(600);
		AGACharacterlistAllowedText:SetText("Character list");
		AGACharacterlistAllowedText:SetJustifyH("LEFT");
		local AGAFirstTimeTitleText3 = AGAInt_Characters:CreateFontString(nil, "OVERLAY", "GameFontNormal");
		AGAFirstTimeTitleText3:SetPoint("TOPLEFT", 10, -40);
		AGAFirstTimeTitleText3:SetWidth(600);
		AGAFirstTimeTitleText3:SetJustifyH("LEFT");
		AGAFirstTimeTitleText3:SetText('|cff00ff00Allowed:|r '..alloweduserlist..'\n\n'..'|r|cffE05555Blocked:|r '..blockeduserlist);		
	-- Help --
		local AGAHelpText = AGAInt_Help:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge");
		AGAHelpText:SetPoint("TOPLEFT", 10, -15);
		AGAHelpText:SetWidth(600);
		AGAHelpText:SetText("Help");
		AGAHelpText:SetJustifyH("LEFT");
		local AGAHelpText1 = AGAInt_Help:CreateFontString(nil, "OVERLAY", "GameFontNormal");
		AGAHelpText1:SetPoint("TOPLEFT", 10, -40);
		AGAHelpText1:SetWidth(600);
		AGAHelpText1:SetJustifyH("LEFT");
		AGAHelpText1:SetText("\n|cffBABABAGeneral commands:\n"
				.."\n|cff00FF7F/aga |rhelp"
				.."\n|cff00FF7F/aga |rshow |cff00E5EEor|r list"
				.."\n|cff00FF7F/aga |rconfig"
				.."\n|cff00FF7F/aga |rsilence |cff00E5EEor|r quiet |cff00E5EEor|r mute"
				.."\n|cff00FF7F/aga |rpurgeall -- Empties character lists."
				.."\n\n|cffBABABAGroup toggle commands:\n"
				.."\n|cff00FF7F/aga |cff00ff00toggle|r friends |cff00E5EEor|r friend"
				.."\n|cff00FF7F/aga |cff00ff00toggle|r bnfriends |cff00E5EEor|r bnfriend"
				.."\n|cff00FF7F/aga |cff00ff00toggle|r guild |cff00E5EEor|r guildies"
				.."\n|cff00FF7F/aga |cff00ff00toggle|r addon |cff00E5EEor|r plugin"
				.."\n\n|cffBABABACharacter specific commands:\n"
				.."\n|cff00FF7F/aga |radd|r <character>"
				.."\n|cff00FF7F/aga |rremove|r <character>"
				.."\n|cff00FF7F/aga |rblock|r <character>"	
				.."\n|cff00FF7F/aga |runblock|r <character>");
	--------------------------------------------------------------------------------------------------
	-- CheckBoxes + Text ----------------------------------------------------------------------------- 
	--------------------------------------------------------------------------------------------------
	-- IsActive --
		local AGAIsActiveBox = CreateFrame("CheckButton", "AGAIsActiveBox", AGAInterfaceAddons, "ChatConfigCheckButtonTemplate");
		AGAIsActiveBox:SetPoint("TOPLEFT", 10, -50);
		AGAIsActiveBox.tooltip = "Allow the addon to work its magic.";
		AGAIsActiveBox:SetScript("OnClick", function() if sUseGlobals == false then if sIsActive == true then sIsActive = false; else sIsActive = true; end else if sIsActiveGLOBAL == true then sIsActiveGLOBAL = false; else sIsActiveGLOBAL = true; end end GetAllowedUsers(); PlaySound("igMainMenuOptionCheckBoxOn", "SFX"); end);		
		local AGAIsActiveText = AGAInterfaceAddons:CreateFontString(nil, "OVERLAY", "GameFontNormal");
		AGAIsActiveText:SetPoint("TOPLEFT", 40, -55 );
		AGAIsActiveText:SetText("Enable addon");
	-- IsFriendBool --
		local AGAIsFriendBoolBox = CreateFrame("CheckButton", "AGAIsFriendBoolBox", AGAInterfaceAddons, "ChatConfigCheckButtonTemplate");
		AGAIsFriendBoolBox:SetPoint("TOPLEFT", 10, -50-60);
		AGAIsFriendBoolBox.tooltip = "Accept party invites from character's friends.";
		AGAIsFriendBoolBox:SetScript("OnClick", function() if sUseGlobals == false then if sIsFriendBool == true then sIsFriendBool = false; else sIsFriendBool = true; end else if sIsFriendBoolGLOBAL == true then sIsFriendBoolGLOBAL = false; else sIsFriendBoolGLOBAL = true; end end GetAllowedUsers(); PlaySound("igMainMenuOptionCheckBoxOn", "SFX"); end);		
		local AGAIsFriendBoolText = AGAInterfaceAddons:CreateFontString(nil, "OVERLAY", "GameFontNormal");
		AGAIsFriendBoolText:SetPoint("TOPLEFT", 40, -55-60 );
		AGAIsFriendBoolText:SetText("Enable friend filter");
	-- BNIsFriendBool --
		local AGAIsBNFriendBoolBox = CreateFrame("CheckButton", "AGAIsBNFriendBoolBox", AGAInterfaceAddons, "ChatConfigCheckButtonTemplate");
		AGAIsBNFriendBoolBox:SetPoint("TOPLEFT", 10, -50-85);
		AGAIsBNFriendBoolBox.tooltip = "Accept party invites from Battle.net friends";
		AGAIsBNFriendBoolBox:SetScript("OnClick", function() if sUseGlobals == false then if sBNIsFriendBool == true then sBNIsFriendBool = false; else sBNIsFriendBool = true; end else if sBNIsFriendBoolGLOBAL == true then sBNIsFriendBoolGLOBAL = false; else sBNIsFriendBoolGLOBAL = true; end end GetAllowedUsers(); PlaySound("igMainMenuOptionCheckBoxOn", "SFX"); end);		
		local AGAIsBNFriendBoolText = AGAInterfaceAddons:CreateFontString(nil, "OVERLAY", "GameFontNormal");
		AGAIsBNFriendBoolText:SetPoint("TOPLEFT", 40, -55-85 );
		AGAIsBNFriendBoolText:SetText("Enable Battle.net friend filter");
	-- IsGuildBool --
		local AGAIsGuildBoolBox = CreateFrame("CheckButton", "AGAIsGuildBoolBox", AGAInterfaceAddons, "ChatConfigCheckButtonTemplate");
		AGAIsGuildBoolBox:SetPoint("TOPLEFT", 10, -50-110);
		AGAIsGuildBoolBox.tooltip = "Accept party invites from guild members.";
		AGAIsGuildBoolBox:SetScript("OnClick", function() if sUseGlobals == false then if sIsGuildBool == true then sIsGuildBool = false; else sIsGuildBool = true; end else if sIsGuildBoolGLOBAL == true then sIsGuildBoolGLOBAL = false; else sIsGuildBoolGLOBAL = true; end end GetAllowedUsers(); PlaySound("igMainMenuOptionCheckBoxOn", "SFX"); end);	
		local AGAIsGuildBoolText = AGAInterfaceAddons:CreateFontString(nil, "OVERLAY", "GameFontNormal");
		AGAIsGuildBoolText:SetPoint("TOPLEFT", 40, -55-110 );
		AGAIsGuildBoolText:SetText("Enable guild member filter");	
	-- IsSilence --
		local AGAIsSilenceBox = CreateFrame("CheckButton", "AGAIsSilenceBox", AGAInterfaceAddons, "ChatConfigCheckButtonTemplate");
		AGAIsSilenceBox:SetPoint("TOPLEFT", 10, -50-135);
		AGAIsSilenceBox.tooltip = "Silence the chat notifications.";
		AGAIsSilenceBox:SetScript("OnClick", function() if sUseGlobals == false then if sIsSilence == true then sIsSilence = false; else sIsSilence = true; end else if sIsSilenceGLOBAL == true then sIsSilenceGLOBAL = false; else sIsSilenceGLOBAL = true; end end GetAllowedUsers(); PlaySound("igMainMenuOptionCheckBoxOn", "SFX"); end);
		local AGAIsSilenceText = AGAInterfaceAddons:CreateFontString(nil, "OVERLAY", "GameFontNormal");
		AGAIsSilenceText:SetPoint("TOPLEFT", 40, -55-135 );
		AGAIsSilenceText:SetText("Silence notifications");
	-- IsInRaidInstance --
		local AGAIsInRaidInstanceBox = CreateFrame("CheckButton", "AGAIsInRaidInstanceBox", AGAInterfaceAddons, "ChatConfigCheckButtonTemplate");
		AGAIsInRaidInstanceBox:SetPoint("TOPLEFT", 10, -50-160);
		AGAIsInRaidInstanceBox.tooltip = "Prevent the addon from accepting invites while in raid instances.";
		AGAIsInRaidInstanceBox:SetScript("OnClick", function() if sUseGlobals == false then if sIsInRaidInstance == true then sIsInRaidInstance = false; else sIsInRaidInstance = true; end else if sIsInRaidInstanceGLOBAL == true then sIsInRaidInstanceGLOBAL = false; else sIsInRaidInstanceGLOBAL = true; end end GetAllowedUsers(); PlaySound("igMainMenuOptionCheckBoxOn", "SFX"); end);
		local AGAIsInRaidInstanceText = AGAInterfaceAddons:CreateFontString(nil, "OVERLAY", "GameFontNormal");
		AGAIsInRaidInstanceText:SetPoint("TOPLEFT", 40, -55-160 );
		AGAIsInRaidInstanceText:SetText("Disable addon while in raid instance.");
	-- IsGlobal --
		local AGAUseGlobalsBox = CreateFrame("CheckButton", "AGAUseGlobals", AGAInterfaceAddons, "ChatConfigCheckButtonTemplate");
		AGAUseGlobalsBox:SetPoint("TOPLEFT", 10, -50-25);
		AGAUseGlobalsBox.tooltip = "Global settings are shared on all the characters if enabled.";
		AGAUseGlobalsBox:SetScript("OnClick", function() if sUseGlobals == true then sUseGlobals = false; else sUseGlobals = true; end GetAllowedUsers(); PlaySound("igMainMenuOptionCheckBoxOn", "SFX"); updateCheckboxes();
	-- -- -- -- Show default text instead of the if statement -- -- -- -- 
		if sUseGlobals == false then
			AGAReset:SetScript("OnClick", function() StaticPopup_Show("Reset_popup") end);
			StaticPopupDialogs["Reset_popup"] = {
				text = "Are you sure you want to reset the AutoGroupAccept Addon for this specific character?",
				button1 = "Yes", button2 = "No",
				OnAccept = function() 
					sTableAdded = {}; sTableBlocked = {}; sIsFriendBool = false; sBNIsFriendBool = false; sIsGuildBool = false; sIsActive = true; sIsSilence = false; sUseGlobals = false;
					updateCheckboxes();
					AGAFirstTime:Show();
					GetAllowedUsers();
					PlaySound("igCharacterInfoOpen", "SFX");
			  end,
				timeout = 0, whileDead = true, hideOnEscape = true, preferredIndex = 3,}
			else
			AGAReset:SetScript("OnClick", function() StaticPopup_Show("Reset_popup") end);
			StaticPopupDialogs["Reset_popup"] = {
				text = "Are you sure you want to reset the AutoGroupAccept Addon for all the |cffE05555(account wide enabled)|r characters?",
				button1 = "Yes", button2 = "No",
				OnAccept = function() 
					sTableAddedGLOBAL = {}; sTableBlockedGLOBAL = {}; sIsFriendBoolGLOBAL = false; sBNIsFriendBoolGLOBAL = false; sIsGuildBoolGLOBAL = false; sIsActiveGLOBAL = true; sIsSilenceGLOBAL = false; sUseGlobals = false; sFirstTime = true;
					updateCheckboxes();
					AGAFirstTime:Show();
					sFirstTime = false;
					GetAllowedUsers();
					PlaySound("igCharacterInfoOpen", "SFX");
			  end,
				timeout = 0, whileDead = true, hideOnEscape = true, preferredIndex = 3,}	
			end
		if sUseGlobals == false then
			AGAPurge:SetScript("OnClick", function() StaticPopup_Show("Purge_popup") end);
			StaticPopupDialogs["Purge_popup"] = {
				text = "Are you sure you want to empty your AutoGroupAccept character lists?",
				button1 = "Yes", button2 = "No",
				OnAccept = function() sTableAdded = {}; sTableBlocked = {}; GetAllowedUsers(); end,
				timeout = 0, whileDead = true, hideOnEscape = true, preferredIndex = 3,}
		else
			AGAPurge:SetScript("OnClick", function() StaticPopup_Show("Purge_popup") end);
			StaticPopupDialogs["Purge_popup"] = {
				text = "Are you sure you want to empty your AutoGroupAccept lists for all the |cffE05555(account wide enabled)|r characters?",
				button1 = "Yes", button2 = "No",
				OnAccept = function() sTableAddedGLOBAL = {}; sTableBlockedGLOBAL = {}; GetAllowedUsers(); end,
				timeout = 0, whileDead = true, hideOnEscape = true, preferredIndex = 3,}
		end
		end);
		local AGAUseGlobalsText = AGAInterfaceAddons:CreateFontString(nil, "OVERLAY", "GameFontNormal");
		AGAUseGlobalsText:SetPoint("TOPLEFT", 40, -55-25 );
		AGAUseGlobalsText:SetText("Enable GLOBAL Settings");
	--------------------------------------------------------------------------------------------------
	-- Buttons ---------------------------------------------------------------------------------------
	--------------------------------------------------------------------------------------------------
	-- igCharacterInfoOpen 
    -- igCharacterInfoClose 
	-- Config FROM first-time --
		local AGAConfigFirstTime = CreateFrame("Button", "AGAConfigFirstTime", AGAFirstTime,"OptionsButtonTemplate");
		AGAConfigFirstTime:SetPoint("BOTTOMLEFT", 14, 16);
		AGAConfigFirstTime:SetText("Config");
		AGAConfigFirstTime:SetScript("OnClick", function()
			AGAFirstTime:Hide();
			PlaySound("igCharacterInfoOpen", "SFX");
			updateCheckboxes();
			updateButtons();
			InterfaceOptionsFrame_OpenToCategory(MyInterfaceOptions.panel);
			InterfaceOptionsFrame_OpenToCategory(MyInterfaceOptions.panel);
		end);
	-- Purge --
		if sUseGlobals == false then
			local AGAPurge = CreateFrame("Button", "AGAPurge", AGAInterfaceAddons,"OptionsButtonTemplate");
			AGAPurge:SetPoint("BOTTOMLEFT", 14, 16);
			AGAPurge:SetText("Purge");
			AGAPurge:SetScript("OnClick", function() StaticPopup_Show("Purge_popup") end);
			StaticPopupDialogs["Purge_popup"] = {
				text = "Are you sure you want to empty your AutoGroupAccept character lists?",
				button1 = "Yes", button2 = "No",
				OnAccept = function() sTableAdded = {}; sTableBlocked = {}; GetAllowedUsers(); end,
				timeout = 0, whileDead = true, hideOnEscape = true, preferredIndex = 3,}
		else
			local AGAPurge = CreateFrame("Button", "AGAPurge", AGAInterfaceAddons,"OptionsButtonTemplate");
			AGAPurge:SetPoint("BOTTOMLEFT", 14, 16);
			AGAPurge:SetText("Purge");
			AGAPurge:SetScript("OnClick", function() StaticPopup_Show("Purge_popup") end);
			StaticPopupDialogs["Purge_popup"] = {
				text = "Are you sure you want to empty your AutoGroupAccept lists for all the |cffE05555(account wide enabled)|r characters?",
				button1 = "Yes", button2 = "No",
				OnAccept = function() sTableAddedGLOBAL = {}; sTableBlockedGLOBAL = {}; GetAllowedUsers(); end,
				timeout = 0, whileDead = true, hideOnEscape = true, preferredIndex = 3,}
		end
	-- Reset --
		local AGAReset = CreateFrame("Button", "AGAReset", AGAInterfaceAddons,"OptionsButtonTemplate");
		AGAReset:SetPoint("BOTTOMLEFT", 14, 40);
		AGAReset:SetText("Reset");
		if sUseGlobals == false then
		AGAReset:SetScript("OnClick", function() StaticPopup_Show("Reset_popup") end);
		StaticPopupDialogs["Reset_popup"] = {
			text = "Are you sure you want to reset the AutoGroupAccept Addon for this specific character?",
			button1 = "Yes", button2 = "No",
			OnAccept = function() 
				sTableAdded = {}; sTableBlocked = {}; sIsFriendBool = false; sBNIsFriendBool = false; sIsGuildBool = false; sIsActive = true; sIsSilence = false; sUseGlobals = false;
				updateCheckboxes();
				updateButtons();
				GetAllowedUsers();
				AGAFirstTime:Show();
				PlaySound("igCharacterInfoOpen", "SFX");
		  end,
			timeout = 0, whileDead = true, hideOnEscape = true, preferredIndex = 3,}
		else
		AGAReset:SetScript("OnClick", function() StaticPopup_Show("Reset_popup") end);
		StaticPopupDialogs["Reset_popup"] = {
			text = "Are you sure you want to reset the AutoGroupAccept Addon for all the |cffE05555(account wide enabled)|r characters?",
			button1 = "Yes", button2 = "No",
			OnAccept = function() 
				sTableAddedGLOBAL = {}; sTableBlockedGLOBAL = {}; sIsFriendBoolGLOBAL = false; sBNIsFriendBoolGLOBAL = false; sIsGuildBoolGLOBAL = false; sIsActiveGLOBAL = true; sIsSilenceGLOBAL = false; sUseGlobals = false; sFirstTime = true;
				updateCheckboxes();
				updateButtons();
				GetAllowedUsers();
				AGAFirstTime:Show();
				sFirstTime = false;
				PlaySound("igCharacterInfoOpen", "SFX");
		  end,
			timeout = 0, whileDead = true, hideOnEscape = true, preferredIndex = 3,}	
		end
	-- Close first-time --
		local AGACloseFirstTime = CreateFrame("Button", "AGACloseFirstTime", AGAFirstTime,"OptionsButtonTemplate");
		AGACloseFirstTime:SetPoint("BOTTOMRIGHT", -14, 16);
		AGACloseFirstTime:SetText("Close");
		AGACloseFirstTime:SetScript("OnClick", function() AGAFirstTime:Hide(); PlaySound("igCharacterInfoClose", "SFX"); end);	
	-- Start hidden --
		AGAFirstTime:Hide()
	--------------------------------------------------------------------------------------------------
	-- Table value check -----------------------------------------------------------------------------
	--------------------------------------------------------------------------------------------------
		function get_key_for_value( t, value )
			for k,v in pairs(t) do if v==value then return k end end
			return nil
		end
	--------------------------------------------------------------------------------------------------
	-- Update buttons --------------------------------------------------------------------------------
	--------------------------------------------------------------------------------------------------
		function updateButtons()
		if sUseGlobals == false then
			AGAReset:SetScript("OnClick", function() StaticPopup_Show("Reset_popup") end);
			StaticPopupDialogs["Reset_popup"] = {
				text = "Are you sure you want to reset the AutoGroupAccept Addon for this specific character?",
				button1 = "Yes", button2 = "No",
				OnAccept = function() 
					sTableAdded = {}; sTableBlocked = {}; sIsFriendBool = false; sBNIsFriendBool = false; sIsGuildBool = false; sIsActive = true; sIsSilence = false; sUseGlobals = false;
					sIsInRaidInstance = true;
					updateCheckboxes();
					updateButtons();
					GetAllowedUsers();
					AGAFirstTime:Show();
					PlaySound("igCharacterInfoOpen", "SFX");
			  end,
				timeout = 0, whileDead = true, hideOnEscape = true, preferredIndex = 3,}
			else
			AGAReset:SetScript("OnClick", function() StaticPopup_Show("Reset_popup") end);
			StaticPopupDialogs["Reset_popup"] = {
				text = "Are you sure you want to reset the AutoGroupAccept Addon for all the |cffE05555(account wide enabled)|r characters?",
				button1 = "Yes", button2 = "No",
				OnAccept = function() 
					sTableAddedGLOBAL = {}; sTableBlockedGLOBAL = {}; sIsFriendBoolGLOBAL = false; sBNIsFriendBoolGLOBAL = false; sIsGuildBoolGLOBAL = false; sIsActiveGLOBAL = true; sIsSilenceGLOBAL = false; sUseGlobals = true; sFirstTime = true; sIsInRaidInstanceGLOBAL = true;
					updateCheckboxes();
					updateButtons();
					GetAllowedUsers();
					AGAFirstTime:Show();
					sFirstTime = false;
					PlaySound("igCharacterInfoOpen", "SFX");
			  end,
				timeout = 0, whileDead = true, hideOnEscape = true, preferredIndex = 3,}	
			end
		if sUseGlobals == false then
				AGAPurge:SetScript("OnClick", function() StaticPopup_Show("Purge_popup") end);
				StaticPopupDialogs["Purge_popup"] = {
					text = "Are you sure you want to empty your AutoGroupAccept character lists?",
					button1 = "Yes", button2 = "No",
					OnAccept = function() sTableAdded = {}; sTableBlocked = {}; end,
					timeout = 0, whileDead = true, hideOnEscape = true, preferredIndex = 3,}
			else
				AGAPurge:SetScript("OnClick", function() StaticPopup_Show("Purge_popup") end);
				StaticPopupDialogs["Purge_popup"] = {
					text = "Are you sure you want to empty your AutoGroupAccept lists for all the |cffE05555(account wide enabled)|r characters?",
					button1 = "Yes", button2 = "No",
					OnAccept = function() sTableAddedGLOBAL = {}; sTableBlockedGLOBAL = {}; end,
					timeout = 0, whileDead = true, hideOnEscape = true, preferredIndex = 3,}
			end
		end
	--------------------------------------------------------------------------------------------------
	-- Update Allowed/Blocked List -------------------------------------------------------------------
	--------------------------------------------------------------------------------------------------
		function GetAllowedUsers()
			local addedList = "";
			
			if sUseGlobals == false then
				if sIsFriendBool then
					addedList = addedList .. ' [|cff00FF7FFriends|r] ';
				end
				if sBNIsFriendBool then
					addedList = addedList .. ' [|cff00FF7FBNET Friends|r] ';
				end
				if sIsGuildBool then
					addedList = addedList .. ' [|cff00FF7FGuildies|r] ';
				end
				for _, value,k in pairs(sTableAdded) do
					addedList = addedList .. value .. '  ';
				end
				if addedList == "" or addedList == nil then
					addedList = "No added characters.";
				end
			else
				if sIsFriendBoolGLOBAL then
					addedList = addedList .. ' [|cff00FF7FFriends|r] ';
				end
				if sBNIsFriendBoolGLOBAL then
					addedList = addedList .. ' [|cff00FF7FBNET Friends|r] ';
				end
				if sIsGuildBoolGLOBAL then
					addedList = addedList .. ' [|cff00FF7FGuildies|r] ';
				end
				if sTableAddedGLOBAL then
					for _, value,k in pairs(sTableAddedGLOBAL) do
						addedList = addedList .. value .. '  ';
					end
				end
				if addedList == "" or addedList == nil then
					addedList = "No added characters.";
				end
			end
			local blockedList = "";
			if sUseGlobals == false then
				for _, value,k in pairs(sTableBlocked) do
					blockedList = blockedList .. value .. '  ';
				end
				if blockedList == "" or blockedList == nil then
					blockedList = "No blocked characters.";
				end
			else
				for _, value,k in pairs(sTableBlockedGLOBAL) do
					blockedList = blockedList .. value .. '  ';
				end
				if blockedList == "" or blockedList == nil then
					blockedList = "No blocked characters.";
				end
			end
			AGAFirstTimeTitleText3:SetText('|cff00ff00Allowed:|r '..addedList..'\n\n'..'|r|cffE05555Blocked:|r '..blockedList);		
		end
	--------------------------------------------------------------------------------------------------
	-- Update CheckBoxex -----------------------------------------------------------------------------
	--------------------------------------------------------------------------------------------------
		function updateCheckboxes()
			AGAUseGlobalsBox:SetChecked(sUseGlobals);
			if sUseGlobals then
				AGAIsActiveBox:SetChecked(sIsActiveGLOBAL);
			else
				AGAIsActiveBox:SetChecked(sIsActive);
			end
			if sUseGlobals then
				AGAIsFriendBoolBox:SetChecked(sIsFriendBoolGLOBAL);
			else
				AGAIsFriendBoolBox:SetChecked(sIsFriendBool);
			end
			if sUseGlobals then
				AGAIsBNFriendBoolBox:SetChecked(sBNIsFriendBoolGLOBAL);
			else
				AGAIsBNFriendBoolBox:SetChecked(sBNIsFriendBool);
			end
			if sUseGlobals then
				AGAIsGuildBoolBox:SetChecked(sIsGuildBoolGLOBAL);
			else
				AGAIsGuildBoolBox:SetChecked(sIsGuildBool);
			end
			if sUseGlobals then
				AGAIsSilenceBox:SetChecked(sIsSilenceGLOBAL);
			else
				AGAIsSilenceBox:SetChecked(sIsSilence);
			end
			if sUseGlobals then
				AGAIsInRaidInstanceBox:SetChecked(sIsInRaidInstanceGLOBAL);
			else
				AGAIsInRaidInstanceBox:SetChecked(sIsInRaidInstance);
			end
		end
	--------------------------------------------------------------------------------------------------
	-- Commands --------------------------------------------------------------------------------------
	--------------------------------------------------------------------------------------------------
		SLASH_AGA1 = '/aga';
		function SlashCmdList.AGA(msg, editbox)
			local msgTable = {}
			for word in msg:gmatch("%S+") do table.insert(msgTable, word) end
			if msgTable[1] == 'config' then
				--------------------------------------------------------------------------------------------------
				-- SHOW and update all the boxes -----------------------------------------------------------------
				--------------------------------------------------------------------------------------------------
				InterfaceOptionsFrame_OpenToCategory(MyInterfaceOptions.panel);
				InterfaceOptionsFrame_OpenToCategory(MyInterfaceOptions.panel);
				PlaySound("igCharacterInfoOpen", "SFX");
				updateCheckboxes();
				updateButtons();
			elseif msgTable[1] == 'toggle' then
				-------------------------------------------------------------------------------------
				-- Toggle commands ------------------------------------------------------------------
				-------------------------------------------------------------------------------------
				GetAllowedUsers();
				if msgTable[2] == 'friend' or msgTable[2] == 'friends' then
				-- Friend ------------------------
					if sUseGlobals == false then
						if sIsFriendBool == true then
							sIsFriendBool = false;
							AGAIsFriendBoolBox:SetChecked(sIsFriendBool);
							GetAllowedUsers();
							if sIsSilence == false then
								print(signatureColored.." Accept friend(s) off");
							end
						else
							sIsFriendBool = true;
							AGAIsFriendBoolBox:SetChecked(sIsFriendBool);
							GetAllowedUsers();
							if sIsSilence == false then
								print(signatureColored.." Accept friend(s) on");
							end
						end
					else
						if sIsFriendBoolGLOBAL == true then
							sIsFriendBoolGLOBAL = false;
							AGAIsFriendBoolBox:SetChecked(sIsFriendBoolGLOBAL);
							GetAllowedUsers();
							if sIsSilenceGLOBAL == false then
								print(signatureColored.." Accept friend(s) off");
							end
						else
							sIsFriendBoolGLOBAL = true;
							AGAIsFriendBoolBox:SetChecked(sIsFriendBoolGLOBAL);
							GetAllowedUsers();
							if sIsSilenceGLOBAL == false then
								print(signatureColored.." Accept friend(s) on");
							end
						end
					end
				elseif msgTable[2] == 'bnfriend' or msgTable[2] == 'bnfriends' then
					-- Battlenet -----------------
					if sUseGlobals == false then
						if sBNIsFriendBool == true then
							sBNIsFriendBool = false;
							AGAIsBNFriendBoolBox:SetChecked(sBNIsFriendBool);
							GetAllowedUsers();
							if sIsSilence == false then
								print(signatureColored.." Accept Battle.NET friend(s) off");
							end
						else
							sBNIsFriendBool = true;
							AGAIsBNFriendBoolBox:SetChecked(sBNIsFriendBool);
							GetAllowedUsers();
							if sIsSilence == false then
								print(signatureColored.." Accept Battle.NET friend(s) on");
							end
						end
					else
						if sBNIsFriendBoolGLOBAL == true then
							sBNIsFriendBoolGLOBAL = false;
							AGAIsBNFriendBoolBox:SetChecked(sBNIsFriendBoolGLOBAL);
							GetAllowedUsers();
							if sIsSilenceGLOBAL == false then
								print(signatureColored.." Accept Battle.NET friend(s) off");
							end
						else
							sBNIsFriendBoolGLOBAL = true;
							AGAIsBNFriendBoolBox:SetChecked(sBNIsFriendBoolGLOBAL);
							GetAllowedUsers();
							if sIsSilenceGLOBAL == false then
								print(signatureColored.." Accept Battle.NET friend(s) on");
							end
						end
					end
				elseif msgTable[2] == 'guild' or msgTable[2] == 'guildies' then
					-- Guild --------------------
					if sUseGlobals == false then
						if sIsGuildBool == true then
							sIsGuildBool = false;
							AGAIsGuildBoolBox:SetChecked(sIsGuildBool);
							GetAllowedUsers();
							if sIsSilence == false then
								print(signatureColored.." Accept guild member(s) off");
							end
						else
							sIsGuildBool = true;
							AGAIsGuildBoolBox:SetChecked(sIsGuildBool);
							GetAllowedUsers();
							if sIsSilence == false then
								print(signatureColored.." Accept guild member(s) on");
							end
						end
					else
						if sIsGuildBoolGLOBAL == true then
							sIsGuildBoolGLOBAL = false;
							AGAIsGuildBoolBox:SetChecked(sIsGuildBoolGLOBAL);
							GetAllowedUsers();
							if sIsSilenceGLOBAL == false then
								print(signatureColored.." Accept guild member(s) off");
							end
						else
							sIsGuildBoolGLOBAL = true;
							AGAIsGuildBoolBox:SetChecked(sIsGuildBoolGLOBAL);
							GetAllowedUsers();
							if sIsSilenceGLOBAL == false then
								print(signatureColored.." Accept guild member(s) on");
							end
						end
					end
				elseif msgTable[2] == 'addon' or msgTable[2] == 'plugin' then
					-- Addon -------------------
					if sUseGlobals == false then
						if sIsActive == true then
							sIsActive = false;
							AGAIsActiveBox:SetChecked(sIsActive);
							if sIsSilence == false then
								print(signatureColored.." |cffcc0000AutoGroupAccept not accepting invites.");
							end
						else
							sIsActive = true;
							AGAIsActiveBox:SetChecked(sIsActive);
							if sIsSilence == false then
								print(signatureColored.." |cff00cc00AutoGroupAccept accepting invites.");
							end
						end
					else
						if sIsActiveGLOBAL == true then
							sIsActiveGLOBAL = false;
							AGAIsActiveBox:SetChecked(sIsActiveGLOBAL);
							if sIsSilenceGLOBAL == false then
								print(signatureColored.." |cffcc0000AutoGroupAccept not accepting invites.");
							end
						else
							sIsActiveGLOBAL = true;
							AGAIsActiveBox:SetChecked(sIsActiveGLOBAL);
							if sIsSilenceGLOBAL == false then
								print(signatureColored.." |cff00cc00AutoGroupAccept accepting invites.");
							end
						end
					end
				else
					print(signatureColored.." |cff00FF7F/aga |cff00ff00toggle|r friends |cff00E5EEor|r bnfriends |cff00E5EEor|r guildies");
				end
			elseif msgTable[1] == 'help' or msgTable[1] == 'h' or msgTable[1] == '?' then
				InterfaceOptionsFrame_OpenToCategory(MyInterfaceOptions.childpanelHelp);
				InterfaceOptionsFrame_OpenToCategory(MyInterfaceOptions.childpanelHelp);		
			elseif msgTable[1] == 'list' or msgTable[1] == 'show' then
				--------------------------------------------------------------------------------------------------
				-- Character Listing commands --------------------------------------------------------------------
				--------------------------------------------------------------------------------------------------
				InterfaceOptionsFrame_OpenToCategory(MyInterfaceOptions.childpanelList);
				InterfaceOptionsFrame_OpenToCategory(MyInterfaceOptions.childpanelList);
			elseif msgTable[1] == 'add' then
				--------------------------------------------------------------------------------------------------
				-- ADD Command -----------------------------------------------------------------------------------
				--------------------------------------------------------------------------------------------------
				if msgTable[2] ~= nil and msgTable[2] ~= '' then
					local addingCharacter = true;
					if sUseGlobals == false then
						for _, value in pairs(sTableAdded) do
							if string.upper(value) == string.upper(msgTable[2]) then
								addingCharacter = false;
							end
						end
						if addingCharacter then
							table.insert (sTableAdded, msgTable[2]);
							if sIsSilence == false then
								print(signatureColored .. ' ' .. msgTable[2] .. ' has been added.');
							end
						else
							if sIsSilence == false then
								print(signatureColored .. ' ' .. msgTable[2] .. ' is already added.');
							end
						end 
					else
						for _, value in pairs(sTableAddedGLOBAL) do
							if string.upper(value) == string.upper(msgTable[2]) then
								addingCharacter = false;
							end
						end
						if addingCharacter then
							table.insert (sTableAddedGLOBAL, msgTable[2]);
							if sIsSilenceGLOBAL == false then
								print(signatureColored .. ' ' .. msgTable[2] .. ' has been added.');
							end
						else
							if sIsSilenceGLOBAL == false then
								print(signatureColored .. ' ' .. msgTable[2] .. ' is already added.');
							end
						end 
					end
				GetAllowedUsers();
				else
					print(signatureColored .. ' Invalid command usage, |cff00FF7F/aga |cff00ff00add|r <character>');
				end
			elseif msgTable[1] == 'purgeall' then
			--------------------------------------------------------------------------------------------------
			-- Purge Command ---------------------------------------------------------------------------------
			--------------------------------------------------------------------------------------------------
			if sUseGlobals == false then
				sTableAdded = {}
				sTableBlocked = {}
				print(signatureColored .. ' Allowed and Blocked list emptied. ');
			else
				sTableAddedGLOBAL = {}
				sTableBlockedGLOBAL = {}
				print(signatureColored .. '[G] Allowed and Blocked list emptied. ');
			end
			GetAllowedUsers();
			elseif msgTable[1] == 'remove' then
				--------------------------------------------------------------------------------------------------
				-- Remove Command ---------------------------------------------------------------------------------
				--------------------------------------------------------------------------------------------------
				if msgTable[2] ~= nil and msgTable[2] ~= '' then
					local removingCharacter = false;
					local n = 0;
					if sUseGlobals == false then
						for _, value,k in pairs(sTableAdded) do
							if string.upper(value) == string.upper(msgTable[2]) and removingCharacter == false then
								removingCharacter = true;
								n = get_key_for_value( sTableAdded, value )
							end
						end
						if removingCharacter then
							sTableAdded[n] = nil;
							if sIsSilence == false then
								print(signatureColored .. ' ' .. msgTable[2] .. ' has been removed.');	 
							end
						else
							if sIsSilence == false then
								print(signatureColored .. ' ' .. msgTable[2] .. ' is not added.');
							end
						end
					else
						for _, value,k in pairs(sTableAddedGLOBAL) do
							if string.upper(value) == string.upper(msgTable[2]) and removingCharacter == false then
								removingCharacter = true;
								n = get_key_for_value( sTableAddedGLOBAL, value )
							end
						end
						if removingCharacter then
							sTableAddedGLOBAL[n] = nil;
							if sIsSilenceGLOBAL == false then
								print(signatureColored .. ' ' .. msgTable[2] .. ' has been removed.');	 
							end
						else
							if sIsSilenceGLOBAL == false then
								print(signatureColored .. ' ' .. msgTable[2] .. ' is not added.');
							end
						end
					end
				else
					print(signatureColored .. ' Invalid command usage, |cff00FF7F/aga |cff00ff00remove|r <character>');
				end
				GetAllowedUsers();
			elseif msgTable[1] == 'block' then
				--------------------------------------------------------------------------------------------------
				-- Block Command ---------------------------------------------------------------------------------
				--------------------------------------------------------------------------------------------------
				if msgTable[2] ~= nil and msgTable[2] ~= '' then
					local addingCharacter = true;
					if sUseGlobals == false then
						for _, value,k in pairs(sTableBlocked) do
							if string.upper(value) == string.upper(msgTable[2]) then
								addingCharacter = false;
							end
						end
						if addingCharacter then
							table.insert (sTableBlocked, msgTable[2]);
							if sIsSilence == false then
								print(signatureColored .. ' ' .. msgTable[2] .. ' has been blocked.');
							end
						else
							if sIsSilence == false then
								print(signatureColored .. ' ' .. msgTable[2] .. ' is already blocked.');
							end
						end
					else
						for _, value,k in pairs(sTableBlockedGLOBAL) do
							if string.upper(value) == string.upper(msgTable[2]) then
								addingCharacter = false;
							end
						end
						if addingCharacter then
							table.insert (sTableBlockedGLOBAL, msgTable[2]);
							if sIsSilenceGLOBAL == false then
								print(signatureColored .. ' ' .. msgTable[2] .. ' has been blocked.');
							end
						else
							if sIsSilenceGLOBAL == false then
								print(signatureColored .. ' ' .. msgTable[2] .. ' is already blocked.');
							end
						end
					end
				else
					print(signatureColored .. ' Invalid command usage, |cff00FF7F/aga |cff00ff00block|r <character>');
				end
				GetAllowedUsers();
			elseif msgTable[1] == 'unblock' then
				--------------------------------------------------------------------------------------------------
				-- Unblock Command ---------------------------------------------------------------------------------
				--------------------------------------------------------------------------------------------------
				if msgTable[2] ~= nil and msgTable[2] ~= '' then
					local removingCharacter = false;
					local n = 0
					if sUseGlobals == false then
						for _, value in pairs(sTableBlocked) do
							if string.upper(value) == string.upper(msgTable[2]) and removingCharacter == false then
								removingCharacter = true;
								n = get_key_for_value( sTableBlocked, value )
							end
						end
						if removingCharacter then
							sTableBlocked[n] = nil;
							if sIsSilence == false then
								print(signatureColored .. ' ' .. msgTable[2] .. ' has been unblocked.');
							end
						else
							if sIsSilence == false then
								print(signatureColored .. ' ' .. msgTable[2] .. ' is not blocked.');
							end
						end
					else
						for _, value in pairs(sTableBlockedGLOBAL) do
							if string.upper(value) == string.upper(msgTable[2]) and removingCharacter == false then
								removingCharacter = true;
								n = get_key_for_value( sTableBlockedGLOBAL, value )
							end
						end
						if removingCharacter then
							sTableBlockedGLOBAL[n] = nil;
							if sIsSilenceGLOBAL == false then
								print(signatureColored .. ' ' .. msgTable[2] .. ' has been unblocked.');
							end
						else
							if sIsSilenceGLOBAL == false then
								print(signatureColored .. ' ' .. msgTable[2] .. ' is not blocked.');
							end
						end
					end
				else
					print(signatureColored .. ' Invalid command usage, |cff00FF7F/aga |cff00ff00unblock|r <character>');
				end
				GetAllowedUsers();
			elseif msgTable[1] == 'silence' or msgTable[1] == 'quiet' or msgTable[1] == 'mute' then
				if sUseGlobals == false then
					if sIsSilence == true then
						sIsSilence = false;
						AGAIsSilenceBox:SetChecked(sIsSilence);
						print(signatureColored.." Silence deactivated.");
					else
						sIsSilence = true;
						AGAIsSilenceBox:SetChecked(sIsSilence);
						print(signatureColored.." Silence activated.");
					end
				else
					if sIsSilenceGLOBAL == true then
						sIsSilenceGLOBAL = false;
						AGAIsSilenceBox:SetChecked(sIsSilenceGLOBAL);
						print(signatureColored.." Silence deactivated.");
					else
						sIsSilenceGLOBAL = true;
						AGAIsSilenceBox:SetChecked(sIsSilenceGLOBAL);
						print(signatureColored.." Silence activated.");
					end
				end
			else
			-- Open up the config panel in options --
				InterfaceOptionsFrame_OpenToCategory(MyInterfaceOptions.panel);
				InterfaceOptionsFrame_OpenToCategory(MyInterfaceOptions.panel);
			end
			end	

			if sIsFriendBool == nil then
				sIsFriendBool = false;
			end
			if sBNIsFriendBool == nil then
				sBNIsFriendBool = false;
			end
			if sIsGuildBool == nil then
				sIsGuildBool = false;
			end
			if sIsActive == nil then
				sIsActive = true;
			end
			if sIsSilence == nil then
				sIsSilence = false;
			end
			if sIsInRaidInstance == nil then
				sIsInRaidInstance = true;
			end
			if sTableAdded == nil then
				sTableAdded = {}
			end
			if sTableBlocked == nil then
				sTableBlocked = {}
			end
			if sIsFriendBoolGLOBAL == nil then
				sIsFriendBoolGLOBAL = false;
			end
			if sBNIsFriendBoolGLOBAL == nil then
				sBNIsFriendBoolGLOBAL = false;
			end
			if sIsGuildBoolGLOBAL == nil then
				sIsGuildBoolGLOBAL = false;
			end
			if sIsActiveGLOBAL == nil then
				sIsActiveGLOBAL = true;
			end
			if sIsInRaidInstanceGLOBAL == nil then
				sIsInRaidInstanceGLOBAL = true;
			end
			if sIsSilenceGLOBAL == nil then
				sIsSilenceGLOBAL = false;
			end
			if sTableAddedGLOBAL == nil then
				sTableAddedGLOBAL = {}
			end
			if sTableBlockedGLOBAL == nil then
				sTableBlockedGLOBAL = {}
			end
			if sFirstTime == nil then
				sFirstTime = true;
			end
	end
--------------------------------------------------------------------------------------------------
-- Accepting Code --------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------
function AutoGroupAccept_Event(self, event, sender, arg1, ...)
	--------------------------------------------------------------------------------------------------
	-- First time Setup ------------------------------------------------------------------------------
	--------------------------------------------------------------------------------------------------
	if(login and ((event == "ADDON_LOADED" and name == arg1) or (event == "PLAYER_LOGIN"))) then
	login = nil;
		if sFirstTime == true then
			AGAFirstTime:Show()
			PlaySound("igCharacterInfoOpen", "SFX");
			sFirstTime = false;
		end
	end
	--------------------------------------------------------------------------------------------------
	-- Accepting invites from friends ----------------------------------------------------------------
	--------------------------------------------------------------------------------------------------
	if (event == "PARTY_INVITE_REQUEST") then
		local playerNumber = GetNumGroupMembers();
		local inInstance, instanceType = IsInInstance();
		local isRaiding = false;
		if instanceType == "raid" then
			isRaiding = true;
		end
		if (sUseGlobals == true and sIsInRaidInstanceGLOBAL == false) or (sUseGlobals == false and sIsInRaidInstance == false) then
			isRaiding = false;
		end
		if sIsActive == true and playerNumber == 0 and isRaiding == false then
			local isAllowed = false
			-- Get all character names -----------------------------------------------------------------------
			local onlineFriends = GetNumFriends() -- Get all the friends that are on.
			local numBNetOnline = BNGetNumFriends() -- Get the BN Friends that are on
			local numGuildMembers, numOnline, numOnlineAndMobile = GetNumGuildMembers() -- get Guildies
			local checkTableCharacters = {} -- Characters to check later on.
			
			if (sUseGlobals == true and sIsFriendBoolGLOBAL) or (sUseGlobals == false and sIsFriendBool) then
				for i=1, onlineFriends do
					local name, level, class, area, connected, status, note, RAF = GetFriendInfo(i);
					if connected == true then
						table.insert(checkTableCharacters, name);
					end
				end
			end
			if (sUseGlobals == true and sBNIsFriendBoolGLOBAL) or (sUseGlobals == false and sBNIsFriendBool) then
				for i=1, numBNetOnline do
					local presenceID, presenceName, battleTag, isBattleTagPresence, toonName, toonID, client, isOnline, lastOnline, isAFK, isDND, messageText, noteText, isRIDFriend, broadcastTime, canSoR = BNGetFriendInfo(i)
					if isOnline == true then
						table.insert(checkTableCharacters, toonName);
					end
				end
			end
			if (sUseGlobals == true and sIsGuildBoolGLOBAL) or (sUseGlobals == false and sIsGuildBool) then
				for i=1, numOnline do
					local fullName, rank, rankIndex, level, class, zone, note, officernote, online, status, classFileName, achievementPoints, achievementRank, isMobile, canSoR, reputation = GetGuildRosterInfo(i)
					if online == true then
						nameChar, realmName = fullName:match("([^,]+)-([^,]+)")
						table.insert(checkTableCharacters, nameChar);
					end
				end
			end
			--------------------------------------------------------------------------------------------------
			-- Check allowed/blocked list ---------------------------------------------------------------------------------
			--------------------------------------------------------------------------------------------------
			if(sUseGlobals == false) then
				if sTableAdded ~= nil then
					for _, value in pairs(sTableAdded) do
						if string.upper(value) == string.upper(sender) then
							isAllowed = true;
						end	
					end		
				end
			else
				if sTableAddedGLOBAL ~= nil then
					for _, value in pairs(sTableAddedGLOBAL) do
						if string.upper(value) == string.upper(sender) then
							isAllowed = true;
						end	
					end		
				end
			end			
			-- Check if sender is in the table -- 
			for _, value in pairs(checkTableCharacters) do
				if value == sender and isAllowed == false then
					isAllowed = true;
				end
			end
			-- Check if User is blocked -- sTableBlocked
			if(sUseGlobals == false) then
				for _, value in pairs(sTableBlocked) do
					if value == sender then
						isAllowed = false;
						if sIsSilence == false then
							print(signatureColored.." blocked character |cff00FF7F".. tostring(sender) .."|r tried to invite you.");
						end
					end
				end
			else
				for _, value in pairs(sTableBlockedGLOBAL) do
					if value == sender then
						isAllowed = false;
						if sIsSilence == false then
							print(signatureColored.." blocked character |cff00FF7F".. tostring(sender) .."|r tried to invite you.");
						end
					end
				end
			end
			-- Check if everything checks out --
			if isAllowed then
				AcceptGroup();
				if sIsSilence == false then
					print(signatureColored.." You have accepted the invite from |cff00FF7F".. tostring(sender) .."|r.");
				end
				for i=1, STATICPOPUP_NUMDIALOGS do
					local dlg = _G["StaticPopup"..i]
					if dlg.which == "PARTY_INVITE" then
						dlg.inviteAccepted = 1
					break
				end
				end
				StaticPopup_Hide("PARTY_INVITE");
			end
		end
	end
end